<?php
/*
Plugin Name: Skylark Vkontakte Group Wall Auto-Post
Plugin URI:
Description: Automatic post on the Vkontakte Group Wall
Version: 0.2.1
Author: Oleg Zhavoronkin
Author URI:
*/

add_option("skylark_vk_access_token", '', "Vkontakte access token", 'no');		// default value
add_option("skylark_vk_application_id", '', "Vkontakte application id", 'no');		// default value
add_option("skylark_vk_application_key", '', "Vkontakte application secret key", 'no');		// default value
add_option("skylark_vk_group_id", '', "Vkontakte group id", 'no');		// default value

// WP 3.0+
// add_action( 'add_meta_boxes', 'myplugin_add_custom_box' );

// backwards compatible
add_action( 'admin_init', 'myplugin_add_custom_box', 1 );

function myplugin_add_custom_box() {
add_meta_box('vgwp','VKontakte Group Wall Publisher','add_custom_wall_publish_option', 'post');
add_meta_box('vgwp','VKontakte Group Wall Publisher','add_custom_wall_publish_option', 'page');
}



function add_custom_wall_publish_option() {
?>
		<table>
		<tr>
		<th scope="row" style="text-align:right; vertical-align:top;">
		Опции публикации на стену группы ВКонтакте
		</th>
		<td>
			<input type="radio" name="vgwp_publish" checked="1" value="1" id="var1"/><label for="var1">Добавить запись на стену если это первая публикация статьи</label><br /><br />
			<input type="radio" name="vgwp_publish" value="2" id="var2"/><label for="var2">Принудительное добавление записи на стену (при любом обновлении статьи)</label><br /><br />
			<input type="radio" name="vgwp_publish" value="3" id="var3"/><label for="var3">Не публиковать запись на стену</label>
		</td>
		</tr>
		<tr><td colspan="2">&nbsp;</td></tr>
		<tr>
		<th scope="row" style="text-align:right; vertical-align:top;">
		Текст записи, который будет добавлен на стену ВКонтакте
		</th>
		<td>
			<input type="radio" name="vgwp_publish_text_variant" checked="1" value="1" checked="1" id="var4"/><label for="var4">Заголовок статьи</label><br /><br />
			<input type="radio" name="vgwp_publish_text_variant" value="2" id="var5"/><label for="var5">Краткое содержание статьи (Цитата)</label><br /><br />
			<input type="radio" name="vgwp_publish_text_variant" value="3" id="var6"/><label for="var6">Свой текст (введите его ниже)</label><br /><br />

			<textarea name="vgwp_publish_text" stype="width:300px;height:200px"></textarea>
		</td>
		</tr>
		</table>
<?php
}

function skylark_post_on_vkontakte_wall_forced($post_ID) {
	if (isset($_POST['vgwp_publish']) && $_POST['vgwp_publish'] == 2) {
		return skylark_post_on_vkontakte_wall($post_ID);
	}

	return $post_ID;
}

function skylark_post_on_vkontakte_wall($post_ID) {
	if (!isset($_POST['vgwp_publish']) || $_POST['vgwp_publish'] == 3) {
return $post_ID;
}
	
	global $post;
	
$vkontakteApplicationId = get_option('skylark_vk_application_id');
	$vkontakteKey = get_option('skylark_vk_application_key');
	$vkontakteGroupId= get_option('skylark_vk_group_id');

$vkontakteAccessToken = get_option('skylark_vk_access_token');

$link = urlencode(get_permalink($post->ID));

if ($_POST['vgwp_publish_text_variant'] == 1) {
	$text = urlencode(get_the_title() . "\n") . "$link";
} else if ($_POST['vgwp_publish_text_variant'] == 3 && !empty($_POST['vgwp_publish_text'])) {
	$text = urlencode($_POST['vgwp_publish_text'] . "\n") . "$link";
} else if ($_POST['vgwp_publish_text_variant'] == 2) {
	$excerpt = $_POST['excerpt'];
	if (empty($excerpt)) {
		$excerpt = get_the_title();
	} else if (strlen($excerpt > 150)) {
		$excerpt = substr($excerpt,0,147) . '...';
	}
	$text = urlencode($excerpt . "\n") . "$link";
}

if (!extension_loaded('openssl')) {
        dl('openssl.so');
}

$sRequest = "https://api.vkontakte.ru/method/wall.post?owner_id=-$vkontakteGroupId&access_token=$vkontakteAccessToken&message=$text" ;

$ch = curl_init($sRequest);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HEADER, 0);
curl_setopt($ch, CURLOPT_REFERER, $_SERVER['HTTP_REFERER']);
$oResponce = curl_exec($ch);
curl_close($ch);
	return $post_ID;
}

function skylark_vkontakte_wall_post_options_page() {
if ( $_POST['skylark_vk_access_token'] ){
		update_option( 'skylark_vk_access_token', $_POST['skylark_vk_access_token'] );
}
if ( $_POST['skylark_vk_application_id'] ){
update_option( 'skylark_vk_application_id', $_POST['skylark_vk_application_id'] );
}
if ( $_POST['skylark_vk_application_key'] ){
update_option( 'skylark_vk_application_key', $_POST['skylark_vk_application_key'] );
}
if ( $_POST['skylark_vk_group_id'] ){
update_option( 'skylark_vk_group_id', $_POST['skylark_vk_group_id'] );
}

$vkaccesstoken = get_option('skylark_vk_access_token');
$vkontakteApplicationId = get_option('skylark_vk_application_id');
$vkontakteKey = get_option('skylark_vk_application_key');
$vkontakteGroupId= get_option('skylark_vk_group_id');
$pluginDir = WP_PLUGIN_DIR.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));
$pluginUrl = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));

file_put_contents($pluginDir . 'connect.php', str_replace(array('%__APPLICATIONID__%', '%__APPLICATIONKEY__%'), array($vkontakteApplicationId, $vkontakteKey), file_get_contents($pluginDir . 'connecttmpl.php')));

	if (!empty($vkontakteApplicationId) && !empty($vkontakteKey) && !empty($vkontakteGroupId)) {
		$authorize = '
		<div class="wrap">
		<h2>Get the access token for your vkontakte application if you have not get one yet, or if you wish to switch to another vkontakte user.</h2>
		<p>Authorize in Vkontakte, and get the access token. Enter it in the form below. The user, under which you authorize, will be used to post messages on the group wall.</p>
		<iframe src="' . $pluginUrl . 'connect.php"></iframe>
		</div>';
	} else {
		$authorize = '
		<div class="wrap">
		<h2>Please, enter the VKontakte application fields first. Then you will be able to generate the Access Token</h2>
		</div>';
	}

print $authorize . '
	<div class="wrap">
	<h2>Vkontakte Group Wall Post setup</h2>
	<form method="post" action="http://'.$_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'].'">
	<p>Enter the access token for your vkontakte application</p>
	<input type="text" id="skylark_vk_access_token" name="skylark_vk_access_token" value="' . $vkaccesstoken . '">

	<p>Application ID of your vkontakte standalone application</p>
	<input type="text" id="skylark_vk_application_id" name="skylark_vk_application_id" value="' . $vkontakteApplicationId . '">

	<p>Application secret key</p>
	<input type="text" id="skylark_vk_application_key" name="skylark_vk_application_key" value="' . $vkontakteKey . '">

	<p>Vkontakte GroupId you whant to post to</p>
	<input type="text" id="skylark_vk_group_id" name="skylark_vk_group_id" value="' . $vkontakteGroupId. '">

	<p class="submit" style="width:420px;"><input type="submit" value="Submit &raquo;" /></p>
	</form>
	</div>
	';
}

function skylark_vk_group_post_admin_page(){
	add_submenu_page('options-general.php', 'Vkontakte Group Wall Post', 'Vkontakte Group Wall Post', 9, 'skylark-vk-groupwall-post.php', 'skylark_vkontakte_wall_post_options_page');
}

add_action('pending_to_publish', 'skylark_post_on_vkontakte_wall');
add_action('draft_to_publish', 'skylark_post_on_vkontakte_wall');
add_action('new_to_publish', 'skylark_post_on_vkontakte_wall');

add_action('publish_post', 'skylark_post_on_vkontakte_wall_forced');

add_action('admin_menu', 'skylark_vk_group_post_admin_page');